Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## gnu.crypto.jce.cipher
Class Cast5Spi

    java.lang.Object
      |
      +--javax.crypto.CipherSpi
            |
            +--gnu.crypto.jce.cipher.CipherAdapter
                  |
                  +--gnu.crypto.jce.cipher.Cast5Spi

public class Cast5Spi
extends gnu.crypto.jce.cipher.CipherAdapter

The implementation of the `CAST5` (a.k.a. CAST-128) Service Provider Interface (SPI) Adapter.

Field Summary
`protected java.util.Map` | `attributes` Our attributes map.
`protected int` | `blockLen` The length of blocks we are processing.
`protected IBlockCipher` | `cipher` Our cipher instance.
`protected int` | `keyLen` The current key size.
`protected IMode` | `mode` Our mode instance.
`protected IPad` | `pad` Our padding instance.
`protected byte[]` | `partBlock` An incomplete block.
`protected int` | `partLen` The number of bytes in `CipherAdapter.partBlock`.

Constructor Summary
`Cast5Spi()`

Method Summary
`protected byte[]` | `engineDoFinal(byte[] input, int off, int len)` Encrypts or decrypts data in a single-part operation, or finishes a multiple-part operation.
`protected int` | `engineDoFinal(byte[] in, int inOff, int inLen, byte[] out, int outOff)` Encrypts or decrypts data in a single-part operation, or finishes a multiple-part operation.
`protected int` | `engineGetBlockSize()` Returns the block size (in bytes).
`protected byte[]` | `engineGetIV()` Returns the initialization vector (IV) in a new buffer.
`protected int` | `engineGetOutputSize(int inputLen)` Returns the length in bytes that an output buffer would need to be in order to hold the result of the next `update` or `doFinal` operation, given the input length `inputLen` (in bytes).
`protected java.security.AlgorithmParameters` | `engineGetParameters()` Returns the parameters used with this cipher.
`protected void` | `engineInit(int opmode, java.security.Key key, java.security.spec.AlgorithmParameterSpec params, java.security.SecureRandom random)` Initializes this cipher with a key, a set of algorithm parameters, and a source of randomness.
`protected void` | `engineInit(int opmode, java.security.Key key, java.security.AlgorithmParameters params, java.security.SecureRandom random)` Initializes this cipher with a key, a set of algorithm parameters, and a source of randomness.
`protected void` | `engineInit(int opmode, java.security.Key key, java.security.SecureRandom random)` Initializes this cipher with a key and a source of randomness.
`protected void` | `engineSetMode(java.lang.String modeName)` Sets the mode of this cipher.
`protected void` | `engineSetPadding(java.lang.String padName)` Sets the padding mechanism of this cipher.
`protected byte[]` | `engineUpdate(byte[] input, int off, int len)` Continues a multiple-part encryption or decryption operation (depending on how this cipher was initialized), processing another data part.
`protected int` | `engineUpdate(byte[] in, int inOff, int inLen, byte[] out, int outOff)` Continues a multiple-part encryption or decryption operation (depending on how this cipher was initialized), processing another data part.

Methods inherited from class javax.crypto.CipherSpi
`engineGetKeySize, engineUnwrap, engineWrap`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### cipher

    protected IBlockCipher cipher

  Our cipher instance.

### mode

    protected IMode mode

  Our mode instance.

### pad

    protected IPad pad

  Our padding instance.

### keyLen

    protected int keyLen

  The current key size.

### attributes

    protected java.util.Map attributes

  Our attributes map.

### partBlock

    protected byte[] partBlock

  An incomplete block.

### partLen

    protected int partLen

  The number of bytes in `CipherAdapter.partBlock`.

### blockLen

    protected int blockLen

  The length of blocks we are processing.

Constructor Detail

### Cast5Spi

    public Cast5Spi()

Method Detail

### engineSetMode

    protected void engineSetMode(java.lang.String modeName)
                          throws java.security.NoSuchAlgorithmException

  Description copied from class: `CipherSpi`
  Sets the mode of this cipher.

  Specified by:
    `engineSetMode` in class `CipherSpi`
  Parameters:
    `modeName` - the cipher mode
  Throws:
    `java.security.NoSuchAlgorithmException` - if the requested cipher mode does not exist

### engineSetPadding

    protected void engineSetPadding(java.lang.String padName)
                             throws NoSuchPaddingException

  Description copied from class: `CipherSpi`
  Sets the padding mechanism of this cipher.

  Specified by:
    `engineSetPadding` in class `CipherSpi`
  Parameters:
    `padName` - the padding mechanism
  Throws:
    `NoSuchPaddingException` - if the requested padding mechanism does not exist

### engineGetBlockSize

    protected int engineGetBlockSize()

  Description copied from class: `CipherSpi`
  Returns the block size (in bytes).

  Specified by:
    `engineGetBlockSize` in class `CipherSpi`
  Returns:
    the block size (in bytes), or 0 if the underlying algorithm is not a block cipher

### engineGetOutputSize

    protected int engineGetOutputSize(int inputLen)

  Description copied from class: `CipherSpi`
  Returns the length in bytes that an output buffer would need to be in order to hold the result of the next `update` or `doFinal` operation, given the input length `inputLen` (in bytes).

  This call takes into account any unprocessed (buffered) data from a previous `update` call, and padding.

  The actual output length of the next `update` or `doFinal` call may be smaller than the length returned by this method.

  Specified by:
    `engineGetOutputSize` in class `CipherSpi`
  Parameters:
    `inputLen` - the input length (in bytes)
  Returns:
    the required output buffer size (in bytes)

### engineGetIV

    protected byte[] engineGetIV()

  Description copied from class: `CipherSpi`
  Returns the initialization vector (IV) in a new buffer.

  This is useful in the context of password-based encryption or decryption, where the IV is derived from a user-provided passphrase.

  Specified by:
    `engineGetIV` in class `CipherSpi`
  Returns:
    the initialization vector in a new buffer, or null if the underlying algorithm does not use an IV, or if the IV has not yet been set.

### engineGetParameters

    protected java.security.AlgorithmParameters engineGetParameters()

  Description copied from class: `CipherSpi`
  Returns the parameters used with this cipher.

  The returned parameters may be the same that were used to initialize this cipher, or may contain a combination of default and random parameter values used by the underlying cipher implementation if this cipher requires algorithm parameters but was not initialized with any.

  Specified by:
    `engineGetParameters` in class `CipherSpi`
  Returns:
    the parameters used with this cipher, or null if this cipher does not use any parameters.

### engineInit

    protected void engineInit(int opmode,
                              java.security.Key key,
                              java.security.SecureRandom random)
                       throws java.security.InvalidKeyException

  Description copied from class: `CipherSpi`
  Initializes this cipher with a key and a source of randomness.

  The cipher is initialized for one of the following four operations: encryption, decryption, key wrapping or key unwrapping, depending on the value of `opmode`.

  If this cipher requires any algorithm parameters that cannot be derived from the given `key`, the underlying cipher implementation is supposed to generate the required parameters itself (using provider-specific default or random values) if it is being initialized for encryption or key wrapping, and raise an `InvalidKeyException` if it is being initialized for decryption or key unwrapping. The generated parameters can be retrieved using engineGetParameters or engineGetIV (if the parameter is an IV).

  If this cipher (including its underlying feedback or padding scheme) requires any random bytes (e.g., for parameter generation), it will get them from `random`.

  Note that when a Cipher object is initialized, it loses all previously-acquired state. In other words, initializing a Cipher is equivalent to creating a new instance of that Cipher and initializing it.

  Specified by:
    `engineInit` in class `CipherSpi`
  Parameters:
    `opmode` - the operation mode of this cipher (this is one of the following: `ENCRYPT_MODE`, `DECRYPT_MODE`, `WRAP_MODE` or `UNWRAP_MODE`)
    `key` - the encryption key
    `random` - the source of randomness
  Throws:
    `java.security.InvalidKeyException` - if the given key is inappropriate for initializing this cipher, or if this cipher is being initialized for decryption and requires algorithm parameters that cannot be determined from the given key.

### engineInit

    protected void engineInit(int opmode,
                              java.security.Key key,
                              java.security.spec.AlgorithmParameterSpec params,
                              java.security.SecureRandom random)
                       throws java.security.InvalidKeyException,
                              java.security.InvalidAlgorithmParameterException

  Description copied from class: `CipherSpi`
  Initializes this cipher with a key, a set of algorithm parameters, and a source of randomness.

  The cipher is initialized for one of the following four operations: encryption, decryption, key wrapping or key unwrapping, depending on the value of `opmode`.

  If this cipher requires any algorithm parameters and `params` is null, the underlying cipher implementation is supposed to generate the required parameters itself (using provider-specific default or random values) if it is being initialized for encryption or key wrapping, and raise an `InvalidAlgorithmParameterException` if it is being initialized for decryption or key unwrapping. The generated parameters can be retrieved using engineGetParameters or engineGetIV (if the parameter is an IV).

  If this cipher (including its underlying feedback or padding scheme) requires any random bytes (e.g., for parameter generation), it will get them from `random`.

  Note that when a Cipher object is initialized, it loses all previously-acquired state. In other words, initializing a Cipher is equivalent to creating a new instance of that Cipher and initializing it.

  Specified by:
    `engineInit` in class `CipherSpi`
  Parameters:
    `opmode` - the operation mode of this cipher (this is one of the following: `ENCRYPT_MODE`, `DECRYPT_MODE`, `WRAP_MODE` or `UNWRAP_MODE`)
    `key` - the encryption key
    `params` - the algorithm parameters
    `random` - the source of randomness
  Throws:
    `java.security.InvalidKeyException` - if the given key is inappropriate for initializing this cipher
    `java.security.InvalidAlgorithmParameterException` - if the given algorithm parameters are inappropriate for this cipher, or if this cipher is being initialized for decryption and requires algorithm parameters and `params` is null.

### engineInit

    protected void engineInit(int opmode,
                              java.security.Key key,
                              java.security.AlgorithmParameters params,
                              java.security.SecureRandom random)
                       throws java.security.InvalidKeyException,
                              java.security.InvalidAlgorithmParameterException

  Description copied from class: `CipherSpi`
  Initializes this cipher with a key, a set of algorithm parameters, and a source of randomness.

  The cipher is initialized for one of the following four operations: encryption, decryption, key wrapping or key unwrapping, depending on the value of `opmode`.

  If this cipher requires any algorithm parameters and `params` is null, the underlying cipher implementation is supposed to generate the required parameters itself (using provider-specific default or random values) if it is being initialized for encryption or key wrapping, and raise an `InvalidAlgorithmParameterException` if it is being initialized for decryption or key unwrapping. The generated parameters can be retrieved using engineGetParameters or engineGetIV (if the parameter is an IV).

  If this cipher (including its underlying feedback or padding scheme) requires any random bytes (e.g., for parameter generation), it will get them from `random`.

  Note that when a Cipher object is initialized, it loses all previously-acquired state. In other words, initializing a Cipher is equivalent to creating a new instance of that Cipher and initializing it.

  Specified by:
    `engineInit` in class `CipherSpi`
  Parameters:
    `opmode` - the operation mode of this cipher (this is one of the following: `ENCRYPT_MODE`, `DECRYPT_MODE`, `WRAP_MODE` or `UNWRAP_MODE`)
    `key` - the encryption key
    `params` - the algorithm parameters
    `random` - the source of randomness
  Throws:
    `java.security.InvalidKeyException` - if the given key is inappropriate for initializing this cipher
    `java.security.InvalidAlgorithmParameterException` - if the given algorithm parameters are inappropriate for this cipher, or if this cipher is being initialized for decryption and requires algorithm parameters and `params` is null.

### engineUpdate

    protected byte[] engineUpdate(byte[] input,
                                  int off,
                                  int len)

  Description copied from class: `CipherSpi`
  Continues a multiple-part encryption or decryption operation (depending on how this cipher was initialized), processing another data part.

  The first `inputLen` bytes in the `input` buffer, starting at `inputOffset` inclusive, are processed, and the result is stored in a new buffer.

  Specified by:
    `engineUpdate` in class `CipherSpi`
  Parameters:
    `input` - the input buffer
    `off` - the offset in `input` where the input starts
    `len` - the input length
  Returns:
    the new buffer with the result, or null if the underlying cipher is a block cipher and the input data is too short to result in a new block.

### engineUpdate

    protected int engineUpdate(byte[] in,
                               int inOff,
                               int inLen,
                               byte[] out,
                               int outOff)
                        throws ShortBufferException

  Description copied from class: `CipherSpi`
  Continues a multiple-part encryption or decryption operation (depending on how this cipher was initialized), processing another data part.

  The first `inputLen` bytes in the `input` buffer, starting at `inputOffset` inclusive, are processed, and the result is stored in the `output` buffer, starting at `outputOffset` inclusive.

  If the `output` buffer is too small to hold the result, a `ShortBufferException` is thrown.

  Specified by:
    `engineUpdate` in class `CipherSpi`
  Parameters:
    `in` - the input buffer
    `inOff` - the offset in `input` where the input starts
    `inLen` - the input length
    `out` - the buffer for the result
    `outOff` - the offset in `output` where the result is stored
  Returns:
    the number of bytes stored in `output`
  Throws:
    `ShortBufferException` - if the given output buffer is too small to hold the result

### engineDoFinal

    protected byte[] engineDoFinal(byte[] input,
                                   int off,
                                   int len)
                            throws IllegalBlockSizeException,
                                   BadPaddingException

  Description copied from class: `CipherSpi`
  Encrypts or decrypts data in a single-part operation, or finishes a multiple-part operation. The data is encrypted or decrypted, depending on how this cipher was initialized.

  The first `inputLen` bytes in the `input` buffer, starting at `inputOffset` inclusive, and any input bytes that may have been buffered during a previous `update` operation, are processed, with padding (if requested) being applied. The result is stored in a new buffer.

  A call to this method resets this cipher object to the state it was in when previously initialized via a call to `engineInit`. That is, the object is reset and available to encrypt or decrypt (depending on the operation mode that was specified in the call to `engineInit`) more data.

  Specified by:
    `engineDoFinal` in class `CipherSpi`
  Parameters:
    `input` - the input buffer
    `off` - the offset in `input` where the input starts
    `len` - the input length
  Returns:
    the new buffer with the result
  Throws:
    `IllegalBlockSizeException` - if this cipher is a block cipher, no padding has been requested (only in encryption mode), and the total input length of the data processed by this cipher is not a multiple of block size
    `BadPaddingException` - if this cipher is in decryption mode, and (un)padding has been requested, but the decrypted data is not bounded by the appropriate padding bytes

### engineDoFinal

    protected int engineDoFinal(byte[] in,
                                int inOff,
                                int inLen,
                                byte[] out,
                                int outOff)
                         throws BadPaddingException,
                                IllegalBlockSizeException,
                                ShortBufferException

  Description copied from class: `CipherSpi`
  Encrypts or decrypts data in a single-part operation, or finishes a multiple-part operation. The data is encrypted or decrypted, depending on how this cipher was initialized.

  The first `inputLen` bytes in the `input` buffer, starting at `inputOffset` inclusive, and any input bytes that may have been buffered during a previous `update` operation, are processed, with padding (if requested) being applied. The result is stored in the `output` buffer, starting at `outputOffset` inclusive.

  If the `output` buffer is too small to hold the result, a `ShortBufferException` is thrown.

  A call to this method resets this cipher object to the state it was in when previously initialized via a call to `engineInit`. That is, the object is reset and available to encrypt or decrypt (depending on the operation mode that was specified in the call to `engineInit`) more data.

  Specified by:
    `engineDoFinal` in class `CipherSpi`
  Parameters:
    `in` - the input buffer
    `inOff` - the offset in `input` where the input starts
    `inLen` - the input length
    `out` - the buffer for the result
    `outOff` - the offset in `output` where the result is stored
  Returns:
    the number of bytes stored in `output`
  Throws:
    `IllegalBlockSizeException` - if this cipher is a block cipher, no padding has been requested (only in encryption mode), and the total input length of the data processed by this cipher is not a multiple of block size
    `ShortBufferException` - if the given output buffer is too small to hold the result
    `BadPaddingException` - if this cipher is in decryption mode, and (un)padding has been requested, but the decrypted data is not bounded by the appropriate padding bytes

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001, 2002, 2003, 2004 Free Software Foundation, Inc.